(define (script-fu-radial-bend inImage inLayer r R scale)
  (let*
	(
		(width (car (gimp-image-width inImage)))
		(height (car (gimp-image-height inImage)))
		(tiles (* 2 (- R r)))
		(image	(car
				(gimp-image-new width height RGB)
			)
		)
		(layer
			(car
				(gimp-layer-new-from-visible inImage image "radial bend")
			)
		)
		(s (/ (* scale r 2 3.1415) R))		
		(t (* s height))
	)

	(set! r (/ r tiles))
	(set! R (/ R tiles))

	(gimp-image-insert-layer image layer 0 0)
	(gimp-image-scale image width t)

	(gimp-image-resize image width (* t R) 0 0)
	(gimp-layer-resize-to-image-size layer)	

	(let*
		(
			(height2 (car
					(gimp-image-height image)
				)
			)
		)
		(plug-in-tile RUN-NONINTERACTIVE image layer height2 height2 0)
	)
	
	(plug-in-polar-coords RUN-NONINTERACTIVE image layer 100 0 FALSE FALSE TRUE)

	(gimp-image-scale image (* 2 R 128 tiles) (* 2 R 128 tiles))

	(let*	
		(
			(height3 (car
					(gimp-image-height image)
				)
			)
			(width3 (car
					(gimp-image-width image)
				)
			)
		)
		(gimp-image-resize image (/ width3 2) (/ height3 2) (- 0 (/ width3 2)) 0 )
	)
	(gimp-layer-resize-to-image-size layer)	

	(gimp-display-new image)
  )
)

  (script-fu-register
    "script-fu-radial-bend"                        ;func name
    "Radial Bending"                               ;menu label
    "Radially bend a texture (uniformly\
      parametrised along the arc) by\
      specifying the radius."              ;description
    "memo"                             ;author
    "Public Domain, 2012"        ;copyright notice
    "September 28, 2012"                          ;date created
    ""                     ;image type that the script works on
    SF-IMAGE "The Image" 0
    SF-DRAWABLE "The Layer" 0
    SF-ADJUSTMENT  "Central Radius (x128 pixels)"     '(2.5 0.01 100000 0.1 1 2 1)  ;a spin-button
    SF-ADJUSTMENT  "Outer Radius (x128 pixels)"     '(3 0.01 100000 0.1 1 2 1)  ;a spin-button
    SF-ADJUSTMENT  "Scaling Factor Adjustments"     '(1 0.001 10 0.01 0.1 3 1)
  )
  (script-fu-menu-register "script-fu-radial-bend" "<Toolbox>/Xtns")
